function FooterNavigationController($scope, $element, ScreenService, ZhUtil, ApplicationContext){
    
    let footerHtmlNode = $element.get(0);
    let footerProperties;
    window.approvalFooter = {};
    
    function renderElements() {
        if(footerProperties) {
            let first = true;
            footerProperties.elements.forEach(elementDetails => {
                let newElement = createElement(elementDetails);
                newElement.name = ScreenService.i18n(elementDetails.name);
                if(first){
                    newElement.classList.add('active');
                    first = false;
                }
                footerHtmlNode.appendChild(newElement);
            });
        }
    }
    
    /**
        called on ng-init
    */
    $scope.onAttach = function(){
        footerProperties = $scope.templateManager.containers.zeedhi_project.footerProperties;
        renderElements();
    };
    
    function createElement(elementDetails) {
        let elementRoot = document.createElement('span');
        elementRoot.classList.add('footer-element');
        elementRoot.textContent = ScreenService.i18n(elementDetails.name);

        let icon = document.createElement('i');
        icon.classList.add('fas');
        icon.classList.add('fa-' + elementDetails.icon);
        elementRoot.appendChild(icon);
        
        bindListeners(elementRoot, elementDetails);
        return elementRoot;
    }
    
      function getApplicationContextWithEventArgs(eventOwner, eventDetails) {
        ApplicationContext.args = {
            owner: eventOwner,
            e: eventDetails,
        };
        return ApplicationContext;
    }
    
    function bindListeners(element, elementDetails) {
        element.addEventListener('click', event => {
            if($scope.$root.activityStack) {
                $scope.$root.activityStack.forEach(stackPopFunction => stackPopFunction());
                $scope.$root.activityStack = [];
            }
            elementDetails.name = ScreenService.i18n(elementDetails.name);
            highlightElement(elementDetails.name);
            if(elementDetails.code) {
                let scopeToEvalute = getApplicationContextWithEventArgs(elementDetails, event);
                $scope.$eval(elementDetails.code,scopeToEvalute);
            } else if(elementDetails.containerName){
                ScreenService.openWindow(elementDetails.containerName);
            }
        });
    }
    
    function highlightElement(elementName) {
        let footerElements = footerHtmlNode.children;
        for (let i = footerElements.length ; i--; ) {
            if(footerElements[i].classList.contains('active') && ScreenService.i18n(footerElements[i].name) !== ScreenService.i18n(elementName)) {
                footerElements[i].classList.remove('active');
            } else if(footerElements[i].name === elementName) {
                footerElements[i].classList.add('active');
            }
        }
    }
    
    window.approvalFooter.highlightElement = highlightElement;
}