"use strict";
function QRScannerController($scope, ApplicationContext, MessageService) {

    $scope.UIManager = ApplicationContext.UIManager;
    // TODO: make function scoped locally
    $scope.widget.__showCameraPreview = this.__showCameraPreview = () => {
        document.body.classList.add('transparent-bg');
        // maybe an array isn'n the best model, but it's o que tem para janta
        $scope.__widgetVisibilities = $scope.templateManager.container.widgets.map(widget => widget.isVisible); 
        ApplicationContext.UIManager.pushState(() => {
            document.body.classList.remove('transparent-bg');
            for (let i = 0; i < $scope.templateManager.container.widgets.length; i++) {
                const widget = $scope.templateManager.container.widgets[i];
                widget.isVisible = $scope.__widgetVisibilities[i];
            }
            delete $scope.__widgetVisibilities;
            'QRScanner' in window && QRScanner.destroy();
            ApplicationContext.UIManager.goBack();
        });
    };

    // TODO: make function scoped locally
    $scope.widget.__hideCameraPreview = this.__hideCameraPreview = () => {
        ApplicationContext.UIManager.goBack();
    };

    // let bindVisibilityAccessFunctions = function bindVisibilityAccessFunctions() {
    //     Object.defineProperty($scope.widget, 'isVisible', {
    //         set: (newValue) => {
    //             $scope.widget._isVisible = this._isVisible = newValue;
    //         },
    //         get: () => $scope.widget._isVisible = this._isVisible,
    //         // enumerable: true,
    //         // configurable: true
    //     });
    // };
    // // constructor(){
    // // $scope.widget..$ = this.$scope = $scope;
    // $scope.widget._isVisible = this._isVisible = $scope.widget._isVisible;
    // bindVisibilityAccessFunctions();
    // }

    $scope.widget.startScan = this.startScan = (autoEnd = true) =>
        new Promise((resolve, reject) => {
            if('QRScanner' in window) {
                $scope.scanRejector = reject;
                QRScanner.show();
                QRScanner.scan((err, text) => {
                    if (err) {
                        reject(err);
                    } else {
                        resolve(text);
                    }
                    if(autoEnd){
                        this.endScan();
                    }
                });
            } else {
                MessageService.getMessageByCode('QRSCANNER_NOT_AVALIA').then(function(message) {
                    reject(message);
                });
            }
        });


    $scope.widget.endScan = this.endScan = () => {
        if('QRScanner' in window) {
            QRScanner.destroy();
        }
    };

    let requestPermission = () =>
        new Promise((resolve, reject) => {
            if(QRScanner) {
                QRScanner.prepare((err, status) => {
                    if (err) {
                        reject(err);
                    } if (status.authorized) {
                        resolve(true);
                    } else if (status.denied) {
                        resolve(false);
                    } else {
                        resolve(false);
                        // needs better support
                        // we didn't get permission, but we didn't get permanently denied. (On
                        // Android, a denial isn't permanent unless the user checks the "Don't
                        // ask again" box.) We can ask again at the next relevant opportunity.
                    }
                });
            } else {
                MessageService.getMessageByCode('QRSCANNER_NOT_AVALIA').then(function(message) {
                    reject(message);
                });
            }
        });
    ;
    
    $scope.onManualInputCancel = () => {
        // $scope.manualInputPopupValue = "";
        $scope.manualInputActive = false;
    };

    $scope.onManualInputConfirm = (typedValue, autoEnd = false) => {
        if(autoEnd){
            this.endScan();
        }
        $scope.manualInputActive = false;
        // if($scope.scanRejector){
        //     $scope.scanRejector('manuallyTyped');
        //     delete $scope.scanRejector;
        // }
        if($scope.widget.onManualQRCodeTyped){
            $scope.$eval($scope.widget.onManualQRCodeTyped, 
                Object.assign(
                    {
                        typedValue: typedValue || ""
                    }, 
                    ApplicationContext
                )
            );
        }
    };
}