var LoginService = function(eventAggregator, EngineService, templateManager, ZHPromise, restEngine, MessageService) {

    // ------------------------ Public Functions -------------------------
    this.containsSericeUrls = function() {
        if (window.serviceUrls && window.serviceUrls.length > 0) {
            return true;
        } else {
            return false;
        }
    };

    this.getBaseUri = function() {
        return EngineService.getLocalVar('baseUri');
    };

    this.getProtocol = function() {
        return EngineService.getLocalVar('protocol');
    };

    this.login = function(data, attempts) {
        var filter;

        try {
            filter = [{
                name: "EMAIL",
                operator: "=",
                value: data.email
            }, {
                name: "PASSWORD",
                operator: "=",
                value: data.password
            }, {
                name: 'PRODUCT_ID',
                operator: '=',
                value: window.projectId
            }, {
                name: 'REQUESTER_URL',
                operator: '=',
                value: document.location.href
            }, {
                name: 'ATTEMPTS',
                operator: '=',
                value: attempts
            }];
        } catch (e) {
            var defer = ZHPromise.defer();
            defer.reject(e);
            return defer;
        }

        return EngineService.authenticate(filter);
        /*.then(function(userData) {
                    return userData;
                }).catch(function(error) {
                    return error;
                });*/
    };

    this.logout = function() {
        return EngineService.logout().then(function() {
            EngineService.setLocalVar('login', 'notLogged');
            localStorage.removeItem('authToken');
            openWindow(templateManager.project.mainWindow);
        });
    };

    this.testUrl = function(baseUri) {

        // baseUri = baseUri ? baseUri.split(/:\/\/www\.|:\/\/|www\./) : [];
        // baseUri = baseUri.pop();
        // var alias;

        try {
            alias = EngineService.getProductAlias();
        } catch (e) {
            var defer = ZHPromise.defer();
            defer.reject(e);
            return defer;
        }

        if (baseUri.indexOf(alias) === -1) {
            baseUri = baseUri + alias;
        }

        return EngineService.testUrl(baseUri).then(function() {
            // EngineService.setLocalVar('baseUri', baseUri);
            // EngineService.setLocalVar('protocol', 'https');
            EngineService.buildUrls();
            return baseUri;
        }, function() {
            return 'Address not found.';
        });

    };

    this.reLogin = () => {
        return new Promise((resolve, reject) => {
            let token = getLocalVar('authToken');
            let isLogged = (getLocalVar('login') === 'logged');
            if (token && isLogged) {
                return restEngine.post('sup#/getLoginByToken', {
                    "requestType": "Row",
                    "row": {
                        token: token
                    }
                }).then(userData => {
                    let dataToLogin = {
                        email: userData.dataset.user.EMAIL,
                        password: userData.dataset.user.PS,
                    };
                    this.login(dataToLogin, 1).then(response => {
                        templateManager.container.getActiveWidget().reload();
                        resolve();
                    }, error => {
                        reject(error);
                        // console.log(error);
                    });
                });
            } else {
                MessageService.getMessageByCode('NO_PROV_TOKEN').then(function(message) {
                    reject(message);
                });
            }
        });
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('LoginService', LoginService);
});
